math2d = require "math2d"
function get_area(pos, size) -- cannot use math2d.bounding_box.create_from_centre because of floor and ceil
	pos = math2d.position.ensure_xy(pos)
	return {left_top={x=math.floor(pos.x - size), y=math.floor(pos.y - size)}, right_bottom={x=math.ceil(pos.x + size), y=math.ceil(pos.y + size)}}
end

function get_area_positions(area)
	local arr = {}
	for x=area.left_top.x,area.right_bottom.x,1 do
		for y=area.left_top.y,area.right_bottom.y,1 do
			table.insert(arr, {x, y})
		end
	end
	return arr
end

commands.add_command("test", nil, function(cmd)
	local params = {}
	for i in string.gmatch(cmd.parameter or "", "%S+") do
		table.insert(params, i)
	end
	local player = game.get_player(cmd.player_index)
	local surface = player.surface
	area_positions = get_area_positions(get_area(player.position, 3))
	for _, pos in ipairs(area_positions) do
		--s.create_entity{name="cliff", position=pos}
	end
	local proto = "copper-ore"
	for _, pos in ipairs(area_positions) do
		--game.print((surface.find_entities_filtered{position=pos}[1] or {name="nil"}).name)
				--game.print(serpent.block(surface.find_entity("copper-ore", pos)))
				--game.print(pos[1].." "..pos[2].." "..proto.." "..tostring(surface.entity_prototype_collides(proto, pos, false)))
				--local e = surface.create_entity{name = proto, position = pos, force = game.forces.neutral, enable_cliff_removal = false, amount = 500}
				--game.print(surface.get_tile(pos[1], pos[2]).name)
				if surface.entity_prototype_collides(proto, pos, false) and surface.get_tile(pos[1], pos[2]).name ~= "out-of-map" then
					
					rendering.draw_circle{color={0, 0, 1}, radius=0.3, filled=true, target={pos[1]+0.5, pos[2]+0.5}, surface=surface, time_to_live=600}
				end
	end
end)